<template lang="pug">
template( v-if='!authProcessing' )
  nav-bar
  .hero.is-fullheight-with-navbar
    .hero-body.has-background-light.is-align-items-stretch.is-flex-direction-column.is-justify-content-flex-start
      .container
        router-view
</template>

<script setup>
import NavBar from "@/components/header/NavBar.vue"

import Notify from "@/assets/notify.mp3"

import toastHtml from "@/common/toastHtml"
import { computed, watch, ref, onMounted } from "vue"
import { useUserStore } from "@/stores/user"
import { useSocket } from "@/stores/socket"
import { useRouter, useRoute } from "vue-router"
import { useToast } from "vue-toastification"

const $router = useRouter()
const $route = useRoute()
const us = useUserStore()
const io = useSocket()
const toast = useToast()

const authProcessing = ref(true)

const fullPath = computed(() => $route.fullPath)
const isLoginRoute = computed(() => fullPath.value == "/")

computed(() => io.on("401", () => {
  us.logout()
  io.stopPooling()
}))

watch(() => ({ ...us.user }), nv => {
  if (nv) {
    io.startPooling()
  } else {
    io.stopPooling()
  }
})

onMounted(async () => {
  if (localStorage.getItem("authorized"))
    await us.authByToken()

  authProcessing.value = false

  io.on("notify", message => {
    toast({
      component: toastHtml,
      props: { content: message }
    })
    
    var audio = new Audio(Notify);
    audio.play()
  })
})
</script>

<style lang="scss">
.container {
  width: 100%!important;
}

.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.25s ease;
	position: absolute;
	top: 0;
	right: 0;
	bottom: 0;
	left: 0;
}
.fade-enter-from,
.fade-leave-to {
  opacity: 0;
	position: absolute;
	top: 0;
	right: 0;
	bottom: 0;
	left: 0;
}

.v-enter-active,
.v-leave-active {
  transition: opacity .2s ease;
}

.v-enter-from,
.v-leave-to {
  opacity: 0;
}
</style>